;; Cairo vector graphics bindings for Chicken Scheme
;
; Copyright (C) 2004, 2005 Michael Bridgen <mikeb@squaremobius.net>,
;                          Tony Garnock-Jones <tonyg@kcbbs.gen.nz>
;                     2008 Luke McCarthy <luke@iogopro.co.uk>
;
; This library is free software; you can redistribute it and/or modify
; it under the terms of the GNU Library General Public License as
; published by the Free Software Foundation; either version 2 of the
; License, or (at your option) any later version.
;
; This library is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; Library General Public License for more details.
;
; You should have received a copy of the GNU Library General Public
; License along with this library; if not, write to the Free
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
; USA

; --------------------------------------------------

(declare
  (usual-integrations)
  (export
    ; version
    *cairo-egg-version*
    cairo-version
    cairo-version-string

    ; context
    cairo-create
    cairo-reference
    cairo-destroy
    cairo-save
    cairo-restore
    cairo-push-group
    cairo-push-group-with-content
    cairo-pop-group
    cairo-pop-group-to-source

    ; state
    cairo-set-operator
    cairo-set-source
    cairo-set-source-rgb
    cairo-set-source-rgba
    cairo-set-source-surface
    cairo-set-tolerance
    cairo-set-antialias
    cairo-set-fill-rule
    cairo-set-line-width
    cairo-set-line-cap
    cairo-set-line-join
    cairo-set-dash
    cairo-set-miter-limit

    ; transformations
    cairo-translate
    cairo-scale
    cairo-rotate
    cairo-transform
    cairo-set-matrix
    cairo-identity-matrix
    cairo-user-to-device
    cairo-user-to-device-distance
    cairo-device-to-user
    cairo-device-to-user-distance

    ; paths
    cairo-new-path
    cairo-move-to
    cairo-new-sub-path
    cairo-line-to
    cairo-curve-to
    cairo-arc
    cairo-arc-negative
    cairo-rel-move-to
    cairo-rel-line-to
    cairo-rel-curve-to
    cairo-rectangle
    cairo-close-path

    ; painting
    cairo-paint
    cairo-paint-with-alpha
    cairo-mask
    cairo-mask-surface
    cairo-stroke
    cairo-stroke-preserve
    cairo-fill
    cairo-fill-preserve
    cairo-copy-page
    cairo-show-page

    ; insideness testing
    cairo-in-stroke
    cairo-in-fill
    cairo-stroke-extents
    cairo-fill-extents

    ; clipping
    cairo-reset-clip
    cairo-clip
    cairo-clip-preserve
    cairo-clip-extents

    ; font options
    cairo-font-options-create
    cairo-font-options-copy
    cairo-font-options-destroy
    cairo-font-options-status
    cairo-font-options-merge
    cairo-font-options-equal
    cairo-font-options-hash
    cairo-font-options-set-antialias
    cairo-font-options-get-antialias
    cairo-font-options-set-subpixel-order
    cairo-font-options-get-subpixel-order
    cairo-font-options-set-hint-style
    cairo-font-options-get-hint-style
    cairo-font-options-set-hint-metrics
    cairo-font-options-get-hint-metrics

    ; fonts
    cairo-select-font-face
    cairo-set-font-size
    cairo-set-font-matrix
    cairo-get-font-matrix
    cairo-set-font-options
    cairo-get-font-options
    cairo-set-font-face
    cairo-get-font-face
    cairo-set-scaled-font
    cairo-get-scaled-font
    cairo-show-text
    cairo-text-path

    ; text extents
    cairo-text-extents
    make-cairo-text-extents-type
    cairo-text-extents-type?
    cairo-text-extents-x-bearing
    cairo-text-extents-y-bearing
    cairo-text-extents-width
    cairo-text-extents-height
    cairo-text-extents-x-advance
    cairo-text-extents-y-advance
    cairo-text-extents-x-bearing-set!
    cairo-text-extents-y-bearing-set!
    cairo-text-extents-width-set!
    cairo-text-extents-height-set!
    cairo-text-extents-x-advance-set!
    cairo-text-extents-y-advance-set!

    ; font extents
    cairo-font-extents
    make-cairo-font-extents-type
    cairo-font-extents-type?
    cairo-font-extents-ascent
    cairo-font-extents-descent
    cairo-font-extents-height
    cairo-font-extents-max-x-advance
    cairo-font-extents-max-y-advance
    cairo-font-extents-ascent-set!
    cairo-font-extents-descent-set!
    cairo-font-extents-height-set!
    cairo-font-extents-max-x-advance-set!
    cairo-font-extents-max-y-advance-set!

    ; font face
    cairo-font-face-reference
    cairo-font-face-destroy
    cairo-font-face-status
    cairo-font-face-get-type

    ; scaled font
    cairo-scaled-font-create
    cairo-scaled-font-reference
    cairo-scaled-font-destroy
    cairo-scaled-font-status
    cairo-scaled-font-get-type
    cairo-scaled-font-extents
    cairo-scaled-font-text-extents
    cairo-scaled-font-get-font-face
    cairo-scaled-font-get-font-matrix
    cairo-scaled-font-get-ctm
    cairo-scaled-font-get-font-options

    ; query state
    cairo-get-operator
    cairo-get-source
    cairo-get-tolerance
    cairo-get-antialias
    cairo-get-current-point
    cairo-get-fill-rule
    cairo-get-line-width
    cairo-get-line-cap
    cairo-get-line-join
    cairo-get-miter-limit
    cairo-get-dash-count
    cairo-get-dash
    cairo-get-matrix
    cairo-get-target
    cairo-get-group-target

    ; error status
    cairo-status
    cairo-status-to-string

    ; surfaces
    cairo-surface-create-similar
    cairo-surface-reference
    cairo-surface-finish
    cairo-surface-destroy
    cairo-surface-status
    cairo-surface-get-type
    cairo-surface-get-content
    cairo-surface-write-to-png
    cairo-surface-get-font-options
    cairo-surface-flush
    cairo-surface-mark-dirty
    cairo-surface-mark-dirty-rectangle
    cairo-surface-set-device-offset
    cairo-surface-get-device-offset
    cairo-surface-set-fallback-resolution

    ; image surfaces
    cairo-image-surface-create
    cairo-image-surface-create-for-data
    cairo-image-surface-get-data
    cairo-image-surface-get-format
    cairo-image-surface-get-width
    cairo-image-surface-get-height
    cairo-image-surface-get-stride
    cairo-image-surface-create-from-png

    ; PDF surfaces
    cairo-pdf-surface-create
    cairo-pdf-surface-set-size

    ; PostScript surfaces
    cairo-ps-surface-create
    cairo-ps-surface-set-size
    cairo-ps-surface-dsc-comment
    cairo-ps-surface-dsc-begin-setup
    cairo-ps-surface-dsc-begin-page-setup

    ; SVG surfaces
    cairo-svg-surface-create
    cairo-svg-surface-restrict-to-version
    cairo-svg-get-versions
    cairo-svg-version-to-string

    ; patterns
    cairo-pattern-create-rgb
    cairo-pattern-create-rgba
    cairo-pattern-create-for-surface
    cairo-pattern-create-linear
    cairo-pattern-create-radial
    cairo-pattern-reference
    cairo-pattern-destroy
    cairo-pattern-status
    cairo-pattern-get-type
    cairo-pattern-add-color-stop-rgb
    cairo-pattern-add-color-stop-rgba
    cairo-pattern-set-matrix
    cairo-pattern-get-matrix
    cairo-pattern-set-extend
    cairo-pattern-get-extend
    cairo-pattern-set-filter
    cairo-pattern-get-filter
    cairo-pattern-get-rgba
    cairo-pattern-get-surface
    cairo-pattern-get-color-stop-rgba
    cairo-pattern-get-color-stop-count
    cairo-pattern-get-linear-points
    cairo-pattern-get-radial-circles

    ; matrix type
    make-cairo-matrix
    cairo-matrix?
    cairo-matrix-xx
    cairo-matrix-yx
    cairo-matrix-xy
    cairo-matrix-yy
    cairo-matrix-x0
    cairo-matrix-y0
    cairo-matrix-xx-set!
    cairo-matrix-yx-set!
    cairo-matrix-xy-set!
    cairo-matrix-yy-set!
    cairo-matrix-x0-set!
    cairo-matrix-y0-set!
    vector->cairo-matrix
    f64vector->cairo-matrix
    cairo-matrix->vector
    cairo-matrix->f64vector

    ; matrix operations
    cairo-matrix-init-identity
    cairo-matrix-init
    cairo-matrix-translate
    cairo-matrix-scale
    cairo-matrix-rotate
    cairo-matrix-invert
    cairo-matrix-multiply
    cairo-matrix-transform-distance
    cairo-matrix-transform-point

    ; cairo_status_t
    CAIRO_STATUS_SUCCESS
    CAIRO_STATUS_NO_MEMORY
    CAIRO_STATUS_INVALID_RESTORE
    CAIRO_STATUS_INVALID_POP_GROUP
    CAIRO_STATUS_NO_CURRENT_POINT
    CAIRO_STATUS_INVALID_MATRIX
    CAIRO_STATUS_INVALID_STATUS
    CAIRO_STATUS_NULL_POINTER
    CAIRO_STATUS_INVALID_STRING
    CAIRO_STATUS_INVALID_PATH_DATA
    CAIRO_STATUS_READ_ERROR
    CAIRO_STATUS_WRITE_ERROR
    CAIRO_STATUS_SURFACE_FINISHED
    CAIRO_STATUS_SURFACE_TYPE_MISMATCH
    CAIRO_STATUS_PATTERN_TYPE_MISMATCH
    CAIRO_STATUS_INVALID_CONTENT
    CAIRO_STATUS_INVALID_FORMAT
    CAIRO_STATUS_INVALID_VISUAL
    CAIRO_STATUS_FILE_NOT_FOUND
    CAIRO_STATUS_INVALID_DASH
    CAIRO_STATUS_INVALID_DSC_COMMENT
    CAIRO_STATUS_INVALID_INDEX
    CAIRO_STATUS_CLIP_NOT_REPRESENTABLE

    ; cairo_content_t
    CAIRO_CONTENT_COLOR
    CAIRO_CONTENT_ALPHA
    CAIRO_CONTENT_COLOR_ALPHA

    ; cairo_operator_t
    CAIRO_OPERATOR_CLEAR
    CAIRO_OPERATOR_SOURCE
    CAIRO_OPERATOR_OVER
    CAIRO_OPERATOR_IN
    CAIRO_OPERATOR_OUT
    CAIRO_OPERATOR_ATOP
    CAIRO_OPERATOR_DEST
    CAIRO_OPERATOR_DEST_OVER
    CAIRO_OPERATOR_DEST_IN
    CAIRO_OPERATOR_DEST_OUT
    CAIRO_OPERATOR_DEST_ATOP
    CAIRO_OPERATOR_XOR
    CAIRO_OPERATOR_ADD
    CAIRO_OPERATOR_SATURATE

    ; cairo_antialias_t
    CAIRO_ANTIALIAS_DEFAULT
    CAIRO_ANTIALIAS_NONE
    CAIRO_ANTIALIAS_GRAY
    CAIRO_ANTIALIAS_SUBPIXEL

    ; cairo_fill_rule_t
    CAIRO_FILL_RULE_WINDING
    CAIRO_FILL_RULE_EVEN_ODD

    ; cairo_line_cap_t
    CAIRO_LINE_CAP_BUTT
    CAIRO_LINE_CAP_ROUND
    CAIRO_LINE_CAP_SQUARE

    ; cairo_line_join_t
    CAIRO_LINE_JOIN_MITER
    CAIRO_LINE_JOIN_ROUND
    CAIRO_LINE_JOIN_BEVEL

    ; cairo_font_slant_t
    CAIRO_FONT_SLANT_NORMAL
    CAIRO_FONT_SLANT_ITALIC
    CAIRO_FONT_SLANT_OBLIQUE

    ; cairo_font_weight_t
    CAIRO_FONT_WEIGHT_NORMAL
    CAIRO_FONT_WEIGHT_BOLD

    ; cairo_subpixel_order_t
    CAIRO_SUBPIXEL_ORDER_DEFAULT
    CAIRO_SUBPIXEL_ORDER_RGB
    CAIRO_SUBPIXEL_ORDER_BGR
    CAIRO_SUBPIXEL_ORDER_VRGB
    CAIRO_SUBPIXEL_ORDER_VBGR

    ; cairo_hint_style_t
    CAIRO_HINT_STYLE_DEFAULT
    CAIRO_HINT_STYLE_NONE
    CAIRO_HINT_STYLE_SLIGHT
    CAIRO_HINT_STYLE_MEDIUM
    CAIRO_HINT_STYLE_FULL

    ; cairo_hint_metrics_t
    CAIRO_HINT_METRICS_DEFAULT
    CAIRO_HINT_METRICS_OFF
    CAIRO_HINT_METRICS_ON

    ; cairo_font_type_t
    CAIRO_FONT_TYPE_TOY
    CAIRO_FONT_TYPE_FT
    CAIRO_FONT_TYPE_WIN32
    CAIRO_FONT_TYPE_ATSUI

    ; cairo_surface_type_t
    CAIRO_SURFACE_TYPE_IMAGE
    CAIRO_SURFACE_TYPE_PDF
    CAIRO_SURFACE_TYPE_PS
    CAIRO_SURFACE_TYPE_XLIB
    CAIRO_SURFACE_TYPE_XCB
    CAIRO_SURFACE_TYPE_GLITZ
    CAIRO_SURFACE_TYPE_QUARTZ
    CAIRO_SURFACE_TYPE_WIN32
    CAIRO_SURFACE_TYPE_BEOS
    CAIRO_SURFACE_TYPE_DIRECTFB
    CAIRO_SURFACE_TYPE_SVG
    CAIRO_SURFACE_TYPE_OS2

    ; cairo_format_t
    CAIRO_FORMAT_ARGB32
    CAIRO_FORMAT_RGB24
    CAIRO_FORMAT_A8
    CAIRO_FORMAT_A1

    ; cairo_svg_version_t
    CAIRO_SVG_VERSION_1_1
    CAIRO_SVG_VERSION_1_2

    ; cairo_pattern_type_t
    CAIRO_PATTERN_TYPE_SOLID
    CAIRO_PATTERN_TYPE_SURFACE
    CAIRO_PATTERN_TYPE_LINEAR
    CAIRO_PATTERN_TYPE_RADIAL

    ; cairo_extend_t
    CAIRO_EXTEND_NONE
    CAIRO_EXTEND_REPEAT
    CAIRO_EXTEND_REFLECT
    CAIRO_EXTEND_PAD

    ; cairo_filter_t
    CAIRO_FILTER_FAST
    CAIRO_FILTER_GOOD
    CAIRO_FILTER_BEST
    CAIRO_FILTER_NEAREST
    CAIRO_FILTER_BILINEAR
    CAIRO_FILTER_GAUSSIAN
))

(use srfi-4 lolevel)

#>
#include <cairo.h>
#include <cairo-pdf.h>
#include <cairo-ps.h>
#include <cairo-svg.h>
<#

; Define an enumeration type. Unlike define-foreign-enum, enumeration values
; are not symbols but are defined as variables.
(define-macro (define-cairo-enum name . enum-names)
  `(begin
     (define-foreign-type ,name
       (enum ,(string-append "_"
                (let ([s (symbol->string name)])
                  (substring s 0 (- (string-length s) 2))))))
     ,@(map (lambda (enum-name)
              `(define ,enum-name (foreign-value ,(symbol->string enum-name) int)))
            enum-names)))

; Define an opaque pointer type with tagging
(define-macro (define-cairo-type name)
  `(define-foreign-type ,name (c-pointer ,(symbol->string name))
     (lambda (x) x)
     (lambda (x) (tag-pointer x ',name))))

;; Version

(define *cairo-egg-version* '(0 1 5 alpha))

(define cairo-version (foreign-lambda int "cairo_version"))

(define cairo-version-string (foreign-lambda c-string "cairo_version_string"))

;; Type defintions

(define-cairo-type cairo_t)
(define-cairo-type cairo_surface_t)
(define-cairo-type cairo_pattern_t)

; cairo_matrix_t represented as record pointing to f64vector of length 6.
(define-record-type cairo-matrix
  (%make-cairo-matrix storage)
  cairo-matrix?
  (storage %cairo-matrix-storage))

; Make a new identity matrix
(define (make-cairo-matrix)
  (%make-cairo-matrix (f64vector 1.0 0.0 0.0 1.0 0.0 0.0)))

(define-foreign-type cairo_matrix_t
  (c-pointer "cairo_matrix_t")
  (lambda (m) (make-locative (%cairo-matrix-storage m))))

(define (cairo-matrix-xx m) (f64vector-ref (%cairo-matrix-storage m) 0))
(define (cairo-matrix-yx m) (f64vector-ref (%cairo-matrix-storage m) 1))
(define (cairo-matrix-xy m) (f64vector-ref (%cairo-matrix-storage m) 2))
(define (cairo-matrix-yy m) (f64vector-ref (%cairo-matrix-storage m) 3))
(define (cairo-matrix-x0 m) (f64vector-ref (%cairo-matrix-storage m) 4))
(define (cairo-matrix-y0 m) (f64vector-ref (%cairo-matrix-storage m) 5))
(define (cairo-matrix-xx-set! m v) (f64vector-set! (%cairo-matrix-storage m) 0 v))
(define (cairo-matrix-yx-set! m v) (f64vector-set! (%cairo-matrix-storage m) 1 v))
(define (cairo-matrix-xy-set! m v) (f64vector-set! (%cairo-matrix-storage m) 2 v))
(define (cairo-matrix-yy-set! m v) (f64vector-set! (%cairo-matrix-storage m) 3 v))
(define (cairo-matrix-x0-set! m v) (f64vector-set! (%cairo-matrix-storage m) 4 v))
(define (cairo-matrix-y0-set! m v) (f64vector-set! (%cairo-matrix-storage m) 5 v))

(define (vector->cairo-matrix v)
  (%make-cairo-matrix
    (f64vector (vector-ref v 0) (vector-ref v 1)
               (vector-ref v 2) (vector-ref v 3)
               (vector-ref v 4) (vector-ref v 5))))

(define (f64vector->cairo-matrix v)
  (%make-cairo-matrix
    (f64vector (f64vector-ref v 0) (f64vector-ref v 1)
               (f64vector-ref v 2) (f64vector-ref v 3)
               (f64vector-ref v 4) (f64vector-ref v 5))))

(define (cairo-matrix->vector m)
  (let ([v (%cairo-matrix-storage m)])
    (vector (f64vector-ref v 0) (f64vector-ref v 1)
            (f64vector-ref v 2) (f64vector-ref v 3)
            (f64vector-ref v 4) (f64vector-ref v 5))))

(define (cairo-matrix->f64vector m)
  (let ([v (%cairo-matrix-storage m)])
    (f64vector (f64vector-ref v 0) (f64vector-ref v 1)
               (f64vector-ref v 2) (f64vector-ref v 3)
               (f64vector-ref v 4) (f64vector-ref v 5))))

(define-record-printer (cairo-matrix m out)
  (fprintf out "#<cairo-matrix [~A ~A | ~A ~A | ~A ~A]>"
           (cairo-matrix-xx m) (cairo-matrix-yx m)
           (cairo-matrix-xy m) (cairo-matrix-yy m)
           (cairo-matrix-x0 m) (cairo-matrix-y0 m)))

(define-cairo-enum cairo_status_t
    CAIRO_STATUS_SUCCESS
    CAIRO_STATUS_NO_MEMORY
    CAIRO_STATUS_INVALID_RESTORE
    CAIRO_STATUS_INVALID_POP_GROUP
    CAIRO_STATUS_NO_CURRENT_POINT
    CAIRO_STATUS_INVALID_MATRIX
    CAIRO_STATUS_INVALID_STATUS
    CAIRO_STATUS_NULL_POINTER
    CAIRO_STATUS_INVALID_STRING
    CAIRO_STATUS_INVALID_PATH_DATA
    CAIRO_STATUS_READ_ERROR
    CAIRO_STATUS_WRITE_ERROR
    CAIRO_STATUS_SURFACE_FINISHED
    CAIRO_STATUS_SURFACE_TYPE_MISMATCH
    CAIRO_STATUS_PATTERN_TYPE_MISMATCH
    CAIRO_STATUS_INVALID_CONTENT
    CAIRO_STATUS_INVALID_FORMAT
    CAIRO_STATUS_INVALID_VISUAL
    CAIRO_STATUS_FILE_NOT_FOUND
    CAIRO_STATUS_INVALID_DASH
    CAIRO_STATUS_INVALID_DSC_COMMENT
    CAIRO_STATUS_INVALID_INDEX
    CAIRO_STATUS_CLIP_NOT_REPRESENTABLE
)

(define-cairo-enum cairo_content_t
    CAIRO_CONTENT_COLOR
    CAIRO_CONTENT_ALPHA
    CAIRO_CONTENT_COLOR_ALPHA
)

;; Functions are mostly in the same order to
;; cairo.h

;; State manipulation
;; -----------------------------------------------

;; cairo_t encapsulates the current state

; formerly didn't take the surface argument
(define cairo-create (foreign-lambda cairo_t "cairo_create"
                                     cairo_surface_t))

; For reference counting?
(define cairo-reference (foreign-lambda void "cairo_reference" cairo_t))

(define cairo-destroy (foreign-lambda void "cairo_destroy" cairo_t))

; Save the state of this context (and keep it as the state)
(define cairo-save (foreign-lambda void "cairo_save" cairo_t))

; Restore the last saved state of this context
(define cairo-restore (foreign-lambda void "cairo_restore" cairo_t))

(define cairo-push-group
  (foreign-lambda void "cairo_push_group" cairo_t))

(define cairo-push-group-with-content
  (foreign-lambda void "cairo_push_group_with_content" cairo_t cairo_content_t))

(define cairo-pop-group
  (foreign-lambda cairo_pattern_t "cairo_pop_group" cairo_t))

(define cairo-pop-group-to-source
  (foreign-lambda void "cairo_pop_group_to_source" cairo_t))

; cairo-copy deprecated

; ------------------------------------------------

; Surfaces and backends
; ------------------------------------------------

;; cairo_surface_t is a drawing surface abstraction

; cairo-create-image deprecated

; cairo-set-target-image deprecated

(define-cairo-enum cairo_operator_t
    CAIRO_OPERATOR_CLEAR

    CAIRO_OPERATOR_SOURCE
    CAIRO_OPERATOR_OVER
    CAIRO_OPERATOR_IN
    CAIRO_OPERATOR_OUT
    CAIRO_OPERATOR_ATOP

    CAIRO_OPERATOR_DEST
    CAIRO_OPERATOR_DEST_OVER
    CAIRO_OPERATOR_DEST_IN
    CAIRO_OPERATOR_DEST_OUT
    CAIRO_OPERATOR_DEST_ATOP

    CAIRO_OPERATOR_XOR
    CAIRO_OPERATOR_ADD
    CAIRO_OPERATOR_SATURATE
)

; Set the composition operator --
; see cairo docs or otherwise what they do.
; http://cairographics.org/samples/snippets.html has
; pictures of the results.
(define cairo-set-operator (foreign-lambda void "cairo_set_operator" cairo_t cairo_operator_t))

(define cairo-set-source
  (foreign-lambda void "cairo_set_source" cairo_t cairo_pattern_t))

; formerly cairo-set-rgb-color
(define cairo-set-source-rgb (foreign-lambda void "cairo_set_source_rgb"
					    cairo_t
					    double ;red
					    double ;green
					    double ;blue
					    ))

;; Also see cairo-paint-with-alpha
(define cairo-set-source-rgba (foreign-lambda void "cairo_set_source_rgba"
					    cairo_t
					    double ;red
					    double ;green
					    double ;blue
                                            double ;alpha
					    ))

(define cairo-set-source-surface
  (foreign-lambda void "cairo_set_source_surface"
                  cairo_t
                  cairo_surface_t
                  double ;x
                  double ;y
                  ))

; ?
(define cairo-set-tolerance (foreign-lambda void "cairo_set_tolerance" cairo_t double))
;; -----------------------------------------------
;;
;; Antialias and fill
;; -----------------------------------------------

(define-cairo-enum cairo_antialias_t
    CAIRO_ANTIALIAS_DEFAULT
    CAIRO_ANTIALIAS_NONE
    CAIRO_ANTIALIAS_GRAY
    CAIRO_ANTIALIAS_SUBPIXEL
)

(define cairo-set-antialias (foreign-lambda void "cairo_set_antialias" cairo_t cairo_antialias_t))

(define-cairo-enum cairo_fill_rule_t
    CAIRO_FILL_RULE_WINDING
    CAIRO_FILL_RULE_EVEN_ODD
)

; Set the fill rule:
; 'winding' is like a union (anything inside a path)
; 'even-odd' is like xor (anything inside an odd number of paths)
(define cairo-set-fill-rule (foreign-lambda void "cairo_set_fill_rule" cairo_t cairo_fill_rule_t))

; ------------------------------------------------

; Lines, joins, and caps
; ------------------------------------------------

(define cairo-set-line-width (foreign-lambda void "cairo_set_line_width" cairo_t double))

(define-cairo-enum cairo_line_cap_t
    CAIRO_LINE_CAP_BUTT
    CAIRO_LINE_CAP_ROUND
    CAIRO_LINE_CAP_SQUARE
)

(define cairo-set-line-cap (foreign-lambda void "cairo_set_line_cap" cairo_t cairo_line_cap_t))

(define-cairo-enum cairo_line_join_t
    CAIRO_LINE_JOIN_MITER
    CAIRO_LINE_JOIN_ROUND
    CAIRO_LINE_JOIN_BEVEL
)

(define cairo-set-line-join (foreign-lambda void "cairo_set_line_join" cairo_t cairo_line_join_t))

(define cairo-set-dash* (foreign-lambda void "cairo_set_dash" cairo_t f64vector int double))

(define (cairo-set-dash cr dashes offset)
  (cairo-set-dash* cr dashes (f64vector-length dashes) offset))

(define cairo-set-miter-limit (foreign-lambda void "cairo_set_miter_limit" cairo_t double))

; ------------------------------------------------

; Context transform operations
; ------------------------------------------------

;; These following operate on the current transform of
;; the context -- there are also operations on arbitrary
;; transforms further on (but perhaps not yet)

(define cairo-translate (foreign-lambda void "cairo_translate" cairo_t double double))

(define cairo-scale (foreign-lambda void "cairo_scale" cairo_t double double))

(define cairo-rotate (foreign-lambda void "cairo_rotate" cairo_t double))

(define cairo-transform (foreign-lambda void "cairo_transform" cairo_t cairo_matrix_t))

(define cairo-set-matrix (foreign-lambda void "cairo_set_matrix" cairo_t cairo_matrix_t))

(define cairo-identity-matrix (foreign-lambda void "cairo_identity_matrix" cairo_t))

;; Matrix operations

; accessors for each element might be nice, but probably not
; immediately necessary

; cairo-concat-matrix replaced by cairo-transform

; cairo-matrix-set replaced by cairo-set-matrix

; was cairo-transform-point
(define cairo-user-to-device*
  (foreign-lambda void "cairo_user_to_device" cairo_t (c-pointer double) (c-pointer double)))

(define (cairo-user-to-device cr x y)
  (let-location ([x double x] [y double y])
    (cairo-user-to-device* cr (location x) (location y))
    (values x y)))

; was cairo-transform-distance
(define cairo-user-to-device-distance*
  (foreign-lambda void "cairo_user_to_device_distance" cairo_t (c-pointer double) (c-pointer double)))

(define (cairo-user-to-device-distance cr dx dy)
  (let-location ([dx double dx] [dy double dy])
    (cairo-user-to-device-distance* cr (location dx) (location dy))
    (values dx dy)))

; was cairo-inverse-transform-point
(define cairo-device-to-user*
  (foreign-lambda void "cairo_device_to_user"
                       cairo_t (c-pointer double) (c-pointer double)))

(define (cairo-device-to-user cr x y)
  (let-location ([x double x] [y double y])
    (cairo-device-to-user* cr x y)
    (values x y)))

; was cairo-inverse-transform-distance
(define cairo-device-to-user-distance*
  (foreign-lambda void "cairo_device_to_user_distance"
                       cairo_t (c-pointer double) (c-pointer double)))

(define (cairo-device-to-user-distance cr x y)
  (let-location ([x double x] [y double y])
    (cairo-device-to-user-distance* cr x y)
    (values x y)))

; ------------------------------------------------

; Path creation
; ------------------------------------------------

;; Note that actually drawing paths is destructive;
;; it will erase the current path.  Use cairo_save
;; and cairo_restore if you want to use a path for
;; more than one drawing operation.  Clipping is
;; _not_ destructive.

(define cairo-new-path (foreign-lambda void "cairo_new_path" cairo_t))

(define cairo-move-to (foreign-lambda void "cairo_move_to" cairo_t double double))

(define cairo-new-sub-path (foreign-lambda void "cairo_new_sub_path" cairo_t))

(define cairo-line-to (foreign-lambda void "cairo_line_to" cairo_t double double))

(define cairo-curve-to (foreign-lambda void "cairo_curve_to" cairo_t double double double double double double))

(define cairo-arc (foreign-lambda void "cairo_arc" cairo_t double double double double double))

(define cairo-arc-negative (foreign-lambda void "cairo_arc_negative" cairo_t double double double double double))

(define cairo-rel-move-to (foreign-lambda void "cairo_rel_move_to" cairo_t double double))

(define cairo-rel-line-to (foreign-lambda void "cairo_rel_line_to" cairo_t double double))

(define cairo-rel-curve-to (foreign-lambda void "cairo_rel_curve_to" cairo_t double double double double double double))

(define cairo-rectangle (foreign-lambda void "cairo_rectangle" cairo_t double double double double))

;; Finish the current shape so you can draw another disjoint one
(define cairo-close-path (foreign-lambda void "cairo_close_path" cairo_t))

; Painting functions

(define cairo-paint (foreign-lambda void
                                    "cairo_paint"
                                    cairo_t
                                    ))

(define cairo-paint-with-alpha  (foreign-lambda void
                                                "cairo_paint_with_alpha"
                                                cairo_t
                                                double
                                                ))

(define cairo-mask (foreign-lambda void "cairo_mask" cairo_t cairo_pattern_t))

(define cairo-mask-surface
  (foreign-lambda void "cairo_mask_surface" cairo_t cairo_surface_t double double))

(define cairo-stroke (foreign-lambda void "cairo_stroke" cairo_t))

(define cairo-stroke-preserve (foreign-lambda void "cairo_stroke_preserve" cairo_t))

(define cairo-fill (foreign-lambda void "cairo_fill" cairo_t))

(define cairo-fill-preserve (foreign-lambda void "cairo_fill_preserve" cairo_t))

(define cairo-copy-page (foreign-lambda void "cairo_copy_page" cairo_t))

(define cairo-show-page (foreign-lambda void "cairo_show_page" cairo_t))

; Insideness testing

(define cairo-in-stroke (foreign-lambda bool "cairo_in_stroke" cairo_t double double))

(define cairo-in-fill (foreign-lambda bool "cairo_in_fill" cairo_t double double))

; Rectangular extents

(define cairo-stroke-extents*
  (foreign-lambda void
                  "cairo_stroke_extents"
                  cairo_t
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)))

(define (cairo-stroke-extents cr)
  (let-location ([x1 double] [y1 double] [x2 double] [y2 double])
    (cairo-stroke-extents* cr (location x1) (location y2) (location x2) (location y2))
    (values x1 y1 x2 y2)))

(define cairo-fill-extents*
  (foreign-lambda void
                  "cairo_fill_extents"
                  cairo_t
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)))

(define (cairo-fill-extents cr)
  (let-location ([x1 double] [y1 double] [x2 double] [y2 double])
    (cairo-fill-extents* cr (location x1) (location y2) (location x2) (location y2))
    (values x1 y1 x2 y2)))

; Clipping
; ------------------------------------------------

;; Clipping does reset the path, unless you use the
;; -preserve functions

; was cairo-init-clip
(define cairo-reset-clip (foreign-lambda void "cairo_reset_clip" cairo_t))

;; Intersect the current path with the clipping region
;; for the new clipping region
(define cairo-clip (foreign-lambda void "cairo_clip" cairo_t))

(define cairo-clip-preserve (foreign-lambda void "cairo_clip_preserve" cairo_t))

(define cairo-clip-extents*
  (foreign-lambda void
                  "cairo_clip_extents"
                  cairo_t
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)))

(define (cairo-clip-extents cr)
  (let-location ([x1 double] [y1 double] [x2 double] [y2 double])
    (cairo-clip-extents* cr (location x1) (location y2) (location x2) (location y2))
    (values x1 y1 x2 y2)))

; Font/Text functions

(define-cairo-type cairo_scaled_font_t)
(define-cairo-type cairo_font_face_t)

; ------------------------------------------------
;
; Fonts and text
; ------------------------------------------------

(define-cairo-enum cairo_font_slant_t
    CAIRO_FONT_SLANT_NORMAL
    CAIRO_FONT_SLANT_ITALIC
    CAIRO_FONT_SLANT_OBLIQUE
)

(define-cairo-enum cairo_font_weight_t
    CAIRO_FONT_WEIGHT_NORMAL
    CAIRO_FONT_WEIGHT_BOLD
)

(define-cairo-enum cairo_subpixel_order_t
    CAIRO_SUBPIXEL_ORDER_DEFAULT
    CAIRO_SUBPIXEL_ORDER_RGB
    CAIRO_SUBPIXEL_ORDER_BGR
    CAIRO_SUBPIXEL_ORDER_VRGB
    CAIRO_SUBPIXEL_ORDER_VBGR
)

(define-cairo-enum cairo_hint_style_t
    CAIRO_HINT_STYLE_DEFAULT
    CAIRO_HINT_STYLE_NONE
    CAIRO_HINT_STYLE_SLIGHT
    CAIRO_HINT_STYLE_MEDIUM
    CAIRO_HINT_STYLE_FULL
)

(define-cairo-enum cairo_hint_metrics_t
    CAIRO_HINT_METRICS_DEFAULT
    CAIRO_HINT_METRICS_OFF
    CAIRO_HINT_METRICS_ON
)

(define-cairo-type cairo_font_options_t)

(define cairo-font-options-create
  (foreign-lambda cairo_font_options_t "cairo_font_options_create"))

(define cairo-font-options-copy
  (foreign-lambda cairo_font_options_t "cairo_font_options_copy" cairo_font_options_t))

(define cairo-font-options-destroy
  (foreign-lambda void "cairo_font_options_destroy" cairo_font_options_t))

(define cairo-font-options-status
  (foreign-lambda cairo_status_t "cairo_font_options_status" cairo_font_options_t))

(define cairo-font-options-merge
  (foreign-lambda void "cairo_font_options_merge" cairo_font_options_t cairo_font_options_t))

(define cairo-font-options-equal
  (foreign-lambda bool "cairo_font_options_equal" cairo_font_options_t cairo_font_options_t))

(define cairo-font-options-hash
  (foreign-lambda unsigned-long "cairo_font_options_hash" cairo_font_options_t))

(define cairo-font-options-set-antialias
  (foreign-lambda void "cairo_font_options_set_antialias" cairo_font_options_t cairo_antialias_t))

(define cairo-font-options-get-antialias
  (foreign-lambda cairo_antialias_t "cairo_font_options_get_antialias" cairo_font_options_t))

(define cairo-font-options-set-subpixel-order
  (foreign-lambda void cairo_font_options_set_subpixel_order cairo_font_options_t cairo_subpixel_order_t))

(define cairo-font-options-get-subpixel-order
  (foreign-lambda cairo_subpixel_order_t "cairo_font_options_get_subpixel_order" cairo_font_options_t))

(define cairo-font-options-set-hint-style
  (foreign-lambda void "cairo_font_options_set_hint_style" cairo_font_options_t cairo_hint_style_t))

(define cairo-font-options-get-hint-style
  (foreign-lambda cairo_hint_style_t "cairo_font_options_get_hint_style" cairo_font_options_t))

(define cairo-font-options-set-hint-metrics
  (foreign-lambda void "cairo_font_options_set_hint_metrics" cairo_font_options_t cairo_hint_metrics_t))

(define cairo-font-options-get-hint-metrics
  (foreign-lambda cairo_hint_metrics_t "cairo_font_options_get_hint_metrics" cairo_font_options_t))

; An easy-osy function for choosing a font to use
; (as usual, affects the context)
; was cairo-select-font
(define cairo-select-font-face
  (foreign-lambda void "cairo_select_font_face"
                  cairo_t
                  c-string
                  cairo_font_slant_t  ; slant
                  cairo_font_weight_t ; weight
                  ))

;; NB regarding font transforms:
;; cairo_gstate.c has notes regarding font co-ordinate
;; systems.  I should read them ;-)

; was cairo-scale-font
(define cairo-set-font-size
  (foreign-lambda void "cairo_set_font_size" cairo_t double))

; was cairo-transform-font
(define cairo-set-font-matrix
  (foreign-lambda void "cairo_set_font_matrix" cairo_t cairo_matrix_t))

(define cairo-get-font-matrix
  (foreign-lambda void "cairo_get_font_matrix" cairo_t cairo_matrix_t))

(define cairo-set-font-options
  (foreign-lambda void "cairo_set_font_options" cairo_t cairo_font_options_t))

(define cairo-get-font-options
  (foreign-lambda void "cairo_get_font_options" cairo_t cairo_font_options_t))

(define cairo-set-font-face
  (foreign-lambda void "cairo_set_font_face" cairo_t cairo_font_face_t))

(define cairo-get-font-face
  (foreign-lambda cairo_font_face_t "cairo_get_font_face" cairo_t))

(define cairo-set-scaled-font
  (foreign-lambda void "cairo_set_scaled_font" cairo_t cairo_scaled_font_t))

(define cairo-get-scaled-font
  (foreign-lambda cairo_scaled_font_t "cairo_get_scaled_font" cairo_t))

(define cairo-show-text
  (foreign-lambda void "cairo_show_text" cairo_t c-string))

; TODO cairo_show_glyphs

(define cairo-text-path
  (foreign-lambda void "cairo_text_path" cairo_t c-string))

; TODO cairo_glyph_path

;; There's also cairo_show_glyphs(), which might be useful
;; if it's worthwhile caching glyphs (I'll look at the cairo
;; source -- it may well convert text to glyphs every time)

;; We want a garbage-collectable type here; wrap a record type around a byte vector buffer, and make
;; chicken type-pun the buffer to the C struct.  We only ever construct these to hand to a function
;; for filling in, so no initialisation needed aside from the buffer.

(define-record-type cairo-text-extents-type
  (%make-cairo-text-extents-type buffer)
  cairo-text-extents-type?
  (buffer cairo-text-extents-type-buffer))

(define (make-cairo-text-extents-type)
  (%make-cairo-text-extents-type
    (make-blob (foreign-value "sizeof(cairo_text_extents_t)" int))))

(define-record-printer (cairo-text-extents-type te out)
  (fprintf out "#<cairo-text-extents ~A ~A ~A ~A ~A ~A>"
           (cairo-text-extents-x-bearing te)
           (cairo-text-extents-y-bearing te)
           (cairo-text-extents-width te)
           (cairo-text-extents-height te)
           (cairo-text-extents-x-advance te)
           (cairo-text-extents-y-advance te)))

(define-foreign-type cairo_text_extents_t
  (c-pointer "cairo_text_extents_t")
  (lambda (te) (make-locative (cairo-text-extents-type-buffer te))))

(define cairo-text-extents-x-bearing (foreign-lambda* double ((cairo_text_extents_t te)) "return(te->x_bearing);"))
(define cairo-text-extents-y-bearing (foreign-lambda* double ((cairo_text_extents_t te)) "return(te->y_bearing);"))
(define cairo-text-extents-width (foreign-lambda* double ((cairo_text_extents_t te)) "return(te->width);"))
(define cairo-text-extents-height (foreign-lambda* double ((cairo_text_extents_t te)) "return(te->height);"))
(define cairo-text-extents-x-advance (foreign-lambda* double ((cairo_text_extents_t te)) "return(te->x_advance);"))
(define cairo-text-extents-y-advance (foreign-lambda* double ((cairo_text_extents_t te)) "return(te->y_advance);"))

(define cairo-text-extents-x-bearing-set! (foreign-lambda* double ((cairo_text_extents_t te) (double v)) "te->x_bearing = v;"))
(define cairo-text-extents-y-bearing-set! (foreign-lambda* double ((cairo_text_extents_t te) (double v)) "te->y_bearing = v;"))
(define cairo-text-extents-width-set! (foreign-lambda* double ((cairo_text_extents_t te) (double v)) "te->width = v;"))
(define cairo-text-extents-height-set! (foreign-lambda* double ((cairo_text_extents_t te) (double v)) "te->height = v;"))
(define cairo-text-extents-x-advance-set! (foreign-lambda* double ((cairo_text_extents_t te) (double v)) "te->x_advance = v;"))
(define cairo-text-extents-y-advance-set! (foreign-lambda* double ((cairo_text_extents_t te) (double v)) "te->y_advance = v;"))

(define-record-type cairo-font-extents-type
  (%make-cairo-font-extents-type buffer)
  cairo-font-extents-type?
  (buffer cairo-font-extents-type-buffer))

(define (make-cairo-font-extents-type)
  (%make-cairo-font-extents-type
    (make-blob (foreign-value "sizeof(cairo_font_extents_t)" int))))

(define-record-printer (cairo-font-extents-type e out)
  (fprintf out "#<cairo-font-extents ~A ~A ~A ~A ~A>"
           (cairo-font-extents-ascent e)
           (cairo-font-extents-descent e)
           (cairo-font-extents-height e)
           (cairo-font-extents-max-x-advance e)
           (cairo-font-extents-max-y-advance e)))

(define-foreign-type cairo_font_extents_t
  (c-pointer "cairo_font_extents_t")
  (lambda (fe) (make-locative (cairo-font-extents-type-buffer fe))))

(define cairo-font-extents-ascent (foreign-lambda* double ((cairo_font_extents_t e)) "return(e->ascent);"))
(define cairo-font-extents-descent (foreign-lambda* double ((cairo_font_extents_t e)) "return(e->descent);"))
(define cairo-font-extents-height (foreign-lambda* double ((cairo_font_extents_t e)) "return(e->height);"))
(define cairo-font-extents-max-x-advance (foreign-lambda* double ((cairo_font_extents_t e)) "return(e->max_x_advance);"))
(define cairo-font-extents-max-y-advance (foreign-lambda* double ((cairo_font_extents_t e)) "return(e->max_y_advance);"))

(define cairo-font-extents-ascent-set! (foreign-lambda* double ((cairo_font_extents_t e) (double v)) "e->ascent = v;"))
(define cairo-font-extents-descent-set! (foreign-lambda* double ((cairo_font_extents_t e) (double v)) "e->descent = v;"))
(define cairo-font-extents-height-set! (foreign-lambda* double ((cairo_font_extents_t e) (double v)) "e->height = v;"))
(define cairo-font-extents-max-x-advance-set! (foreign-lambda* double ((cairo_font_extents_t e) (double v)) "e->max_x_advance = v;"))
(define cairo-font-extents-max-y-advance-set! (foreign-lambda* double ((cairo_font_extents_t e) (double v)) "e->max_y_advance = v;"))

(define cairo-text-extents* (foreign-lambda void "cairo_text_extents" cairo_t c-string cairo_text_extents_t))

; was cairo-current-font-extents
(define cairo-font-extents* (foreign-lambda void "cairo_font_extents" cairo_t cairo_font_extents_t))

(define (cairo-text-extents cr str)
  (let ([te (make-cairo-text-extents-type)])
    (cairo-text-extents* cr str te)
    te))

; TODO cairo_glyph_extents

(define (cairo-font-extents cr)
  (let ([fe (make-cairo-font-extents-type)])
    (cairo-font-extents* cr fe)
    fe))

(define cairo-font-face-reference
  (foreign-lambda cairo_font_face_t "cairo_font_face_reference" cairo_font_face_t))

(define cairo-font-face-destroy
  (foreign-lambda void "cairo_font_face_destroy" cairo_font_face_t))

(define cairo-font-face-status
  (foreign-lambda cairo_status_t "cairo_font_face_status" cairo_font_face_t))

(define-cairo-enum cairo_font_type_t
    CAIRO_FONT_TYPE_TOY
    CAIRO_FONT_TYPE_FT
    CAIRO_FONT_TYPE_WIN32
    CAIRO_FONT_TYPE_ATSUI
)

(define cairo-font-face-get-type
  (foreign-lambda cairo_font_type_t "cairo_font_face_get_type" cairo_font_face_t))

(define cairo-scaled-font-create
  (foreign-lambda cairo_scaled_font_t
                  "cairo_scaled_font_create"
                  cairo_font_face_t
                  cairo_matrix_t
                  cairo_matrix_t
                  cairo_font_options_t))

(define cairo-scaled-font-reference
  (foreign-lambda cairo_scaled_font_t "cairo_scaled_font_reference" cairo_scaled_font_t))

(define cairo-scaled-font-destroy
  (foreign-lambda void "cairo_scaled_font_destroy" cairo_scaled_font_t))

(define cairo-scaled-font-status
  (foreign-lambda cairo_status_t "cairo_scaled_font_status" cairo_scaled_font_t))

(define cairo-scaled-font-get-type
  (foreign-lambda cairo_font_type_t "cairo_scaled_font_get_type" cairo_scaled_font_t))

(define cairo-scaled-font-extents*
  (foreign-lambda void "cairo_scaled_font_extents" cairo_scaled_font_t cairo_font_extents_t))

(define (cairo-scaled-font-extents font)
  (let ([fe (make-cairo-font-extents)])
    (cairo-scaled-font-extents* font fe)
    fe))

(define cairo-scaled-font-text-extents*
  (foreign-lambda void "cairo_scaled_font_text_extents" cairo_scaled_font_t c-string cairo_text_extents_t))

(define (cairo-scaled-font-text-extents font text)
  (let ([te (make-cairo-text-extents)])
    (cairo-scaled-font-text-extents* font text te)
    te))

; TODO cairo_scaled_font_glyph_extents

(define cairo-scaled-font-get-font-face
  (foreign-lambda cairo_font_face_t "cairo_scaled_font_get_font_face" cairo_scaled_font_t))

(define cairo-scaled-font-get-font-matrix
  (foreign-lambda void "cairo_scaled_font_get_font_matrix" cairo_scaled_font_t cairo_matrix_t))

(define cairo-scaled-font-get-ctm
  (foreign-lambda void "cairo_scaled_font_get_ctm" cairo_scaled_font_t cairo_matrix_t))

(define cairo-scaled-font-get-font-options
  (foreign-lambda void "cairo_scaled_font_get_font_options" cairo_scaled_font_t cairo_font_options_t))

; ------------------------------------------------
;
; Context status and query
; ------------------------------------------------

; All these used to be -current-, now -get-

(define cairo-get-operator
  (foreign-lambda cairo_operator_t "cairo_get_operator" cairo_t))

(define cairo-get-source
  (foreign-lambda cairo_pattern_t "cairo_get_source" cairo_t))

(define cairo-get-tolerance
  (foreign-lambda double "cairo_get_tolerance" cairo_t))

(define cairo-get-antialias
  (foreign-lambda cairo_antialias_t "cairo_get_antialias" cairo_t))

(define cairo-get-current-point*
  (foreign-lambda void "cairo_get_current_point" cairo_t (c-pointer double) (c-pointer double)))

(define (cairo-get-current-point cr)
  (let-location ([x double] [y double])
    (cairo-get-current-point* cr (location x) (location y))
    (values x y)))

(define cairo-get-fill-rule
  (foreign-lambda cairo_fill_rule_t "cairo_get_fill_rule" cairo_t))

(define cairo-get-line-width
  (foreign-lambda double "cairo_get_line_width" cairo_t))

(define cairo-get-line-cap
  (foreign-lambda cairo_line_cap_t "cairo_get_line_cap" cairo_t))

(define cairo-get-line-join
  (foreign-lambda cairo_line_join_t "cairo_get_line_join" cairo_t))

(define cairo-get-miter-limit
  (foreign-lambda double "cairo_get_miter_limit" cairo_t))

(define cairo-get-dash-count
  (foreign-lambda int "cairo_get_dash_count" cairo_t))

(define cairo-get-dash*
  (foreign-lambda void "cairo_get_dash" cairo_t f64vector (c-pointer double)))

(define (cairo-get-dash cr)
  (let ([dashes (make-f64vector (cairo-get-dash-count cr))])
    (let-location ([offset double])
      (cairo-get-dash* cr dashes (location offset))
      (values dashes offset))))

(define cairo-get-matrix
  (foreign-lambda void "cairo_get_matrix" cairo_t cairo_matrix_t))

(define cairo-get-target
  (foreign-lambda cairo_surface_t "cairo_get_target" cairo_t))

(define cairo-get-group-target
  (foreign-lambda cairo_surface_t "cairo_get_group_target" cairo_t))

; cairo-current-rgb-color deprecated

; cairo-current-alpha deprecated

(define cairo-status (foreign-lambda cairo_status_t "cairo_status" cairo_t))

(define cairo-status-to-string (foreign-lambda c-string "cairo_status_to_string" cairo_status_t))

; Surface manipulation

(define cairo-surface-create-similar
  (foreign-lambda cairo_surface_t
                  "cairo_surface_create_similar"
                  cairo_surface_t
                  cairo_content_t
                  int    ; width
                  int))  ; height

(define cairo-surface-reference
  (foreign-lambda cairo_surface_t "cairo_surface_reference" cairo_surface_t))

(define cairo-surface-finish
  (foreign-lambda void "cairo_surface_finish" cairo_surface_t))

(define cairo-surface-destroy
  (foreign-lambda void "cairo_surface_destroy" cairo_surface_t))

(define cairo-surface-status
  (foreign-lambda cairo_status_t "cairo_surface_status" cairo_surface_t))

(define-cairo-enum cairo_surface_type_t
    CAIRO_SURFACE_TYPE_IMAGE
    CAIRO_SURFACE_TYPE_PDF
    CAIRO_SURFACE_TYPE_PS
    CAIRO_SURFACE_TYPE_XLIB
    CAIRO_SURFACE_TYPE_XCB
    CAIRO_SURFACE_TYPE_GLITZ
    CAIRO_SURFACE_TYPE_QUARTZ
    CAIRO_SURFACE_TYPE_WIN32
    CAIRO_SURFACE_TYPE_BEOS
    CAIRO_SURFACE_TYPE_DIRECTFB
    CAIRO_SURFACE_TYPE_SVG
    CAIRO_SURFACE_TYPE_OS2
)

(define cairo-surface-get-type
  (foreign-lambda cairo_surface_type_t "cairo_surface_get_type" cairo_surface_t))

(define cairo-surface-get-content
  (foreign-lambda cairo_content_t "cairo_surface_get_content" cairo_surface_t))

(define cairo-surface-write-to-png
  (foreign-lambda cairo_status_t "cairo_surface_write_to_png" cairo_surface_t c-string))

(define cairo-surface-get-font-options
  (foreign-lambda void "cairo_surface_get_font_options" cairo_surface_t cairo_font_options_t))

(define cairo-surface-flush
  (foreign-lambda void "cairo_surface_flush" cairo_surface_t))

(define cairo-surface-mark-dirty
  (foreign-lambda void "cairo_surface_mark_dirty" cairo_surface_t))

(define cairo-surface-mark-dirty-rectangle
  (foreign-lambda void "cairo_surface_mark_dirty_rectangle" cairo_surface_t int int int int))

(define cairo-surface-set-device-offset
  (foreign-lambda void "cairo_surface_set_device_offset" cairo_surface_t double double))

(define cairo-surface-get-device-offset*
  (foreign-lambda void "cairo_surface_get_device_offset" cairo_surface_t (c-pointer double) (c-pointer double)))

(define (cairo-surface-get-device-offset cs)
  (let-location ([x-offset double] [y-offset double])
    (cairo-surface-get-device-offset* cs (location x-offset) (location y-offset))
    (values x-offset y-offset)))

(define cairo-surface-set-fallback-resolution
  (foreign-lambda void "cairo_surface_set_fallback_resolution" cairo_surface_t double double))

(define-cairo-enum cairo_format_t
    CAIRO_FORMAT_ARGB32
    CAIRO_FORMAT_RGB24
    CAIRO_FORMAT_A8
    CAIRO_FORMAT_A1
)

(define cairo-image-surface-create
  (foreign-lambda cairo_surface_t "cairo_image_surface_create" cairo_format_t int int))

(define cairo-image-surface-create-for-data
  (foreign-lambda cairo_surface_t
                  "cairo_image_surface_create_for_data"
                  (c-pointer byte) cairo_format_t int int int))

(define cairo-image-surface-get-data
  (foreign-lambda (c-pointer byte) "cairo_image_surface_get_data" cairo_surface_t))

(define cairo-image-surface-get-format
  (foreign-lambda cairo_format_t "cairo_image_surface_get_format" cairo_surface_t))

(define cairo-image-surface-get-width
  (foreign-lambda int "cairo_image_surface_get_width" cairo_surface_t))

(define cairo-image-surface-get-height
  (foreign-lambda int "cairo_image_surface_get_height" cairo_surface_t))

(define cairo-image-surface-get-stride
  (foreign-lambda int "cairo_image_surface_get_stride" cairo_surface_t))

; PNG Support
(define cairo-image-surface-create-from-png (foreign-lambda cairo_surface_t
                                                            "cairo_image_surface_create_from_png"
                                                            c-string
                                                            ))

;; PDF surfaces

(define cairo-pdf-surface-create
  (foreign-lambda cairo_surface_t "cairo_pdf_surface_create" c-string double double))

; TODO cairo_pdf_surface_create_for_stream

(define cairo-pdf-surface-set-size
  (foreign-lambda void "cairo_pdf_surface_set_size" cairo_surface_t double double))

;; PostScript surfaces

(define cairo-ps-surface-create
  (foreign-lambda cairo_surface_t "cairo_ps_surface_create" c-string double double))

; TODO cairo_ps_surface_create_for_stream

(define cairo-ps-surface-set-size
  (foreign-lambda void "cairo_ps_surface_set_size" cairo_surface_t double double))

(define cairo-ps-surface-dsc-comment
  (foreign-lambda void "cairo_ps_surface_dsc_comment" cairo_surface_t c-string))

(define cairo-ps-surface-dsc-begin-setup
  (foreign-lambda void "cairo_ps_surface_dsc_begin_setup" cairo_surface_t))

(define cairo-ps-surface-dsc-begin-page-setup
  (foreign-lambda void "cairo_ps_surface_dsc_begin_page_setup" cairo_surface_t))

;; SVG surfaces

(define-cairo-enum cairo_svg_version_t
    CAIRO_SVG_VERSION_1_1
    CAIRO_SVG_VERSION_1_2
)

(define cairo-svg-surface-create
  (foreign-lambda cairo_surface_t "cairo_svg_surface_create" c-string double double))

; TODO cairo_svg_surface_create_for_stream

(define cairo-svg-surface-restrict-to-version
  (foreign-lambda void "cairo_svg_surface_restrict_to_version" cairo_surface_t cairo_svg_version_t))

(define cairo-svg-get-versions*
  (foreign-lambda void "cairo_svg_get_versions"
                       (c-pointer (const (c-pointer cairo_svg_version_t)))
                       (c-pointer int)))

(define (cairo-svg-get-versions)
  (let-location ([versions (c-pointer cairo_svg_version_t)] [num int])
    (cairo-svg-get-versions* (location versions) (location num))
    (let loop ([vs '()] [i 0])
      (if (< i num)
          ; warning! pointer arithmetic
          (loop (cons (pointer-u32-ref (pointer-offset versions (* i 4))) vs)
                (+ i 1))
          (reverse vs)))))

(define cairo-svg-version-to-string
  (foreign-lambda c-string "cairo_svg_version_to_string" cairo_svg_version_t))

; ------------------------------------------------
; Patterns
; ------------------------------------------------

(define cairo-pattern-create-rgb
  (foreign-lambda cairo_pattern_t "cairo_pattern_create_rgb" double double double))

(define cairo-pattern-create-rgba
  (foreign-lambda cairo_pattern_t "cairo_pattern_create_rgba" double double double double))

(define cairo-pattern-create-for-surface
  (foreign-lambda cairo_pattern_t "cairo_pattern_create_for_surface" cairo_surface_t))

(define cairo-pattern-create-linear
  (foreign-lambda cairo_pattern_t "cairo_pattern_create_linear"
                                  double double double double))

(define cairo-pattern-create-radial
  (foreign-lambda cairo_pattern_t "cairo_pattern_create_radial"
                                  double double double double double double))

(define cairo-pattern-reference
  (foreign-lambda cairo_pattern_t "cairo_pattern_reference" cairo_pattern_t))

(define cairo-pattern-destroy
  (foreign-lambda void "cairo_pattern_destroy" cairo_pattern_t))

(define cairo-pattern-status
  (foreign-lambda cairo_status_t "cairo_pattern_status" cairo_pattern_t))

(define-cairo-enum cairo_pattern_type_t
    CAIRO_PATTERN_TYPE_SOLID
    CAIRO_PATTERN_TYPE_SURFACE
    CAIRO_PATTERN_TYPE_LINEAR
    CAIRO_PATTERN_TYPE_RADIAL
)

(define cairo-pattern-get-type
  (foreign-lambda cairo_pattern_type_t "cairo_pattern_get_type" cairo_pattern_t))

(define cairo-pattern-add-color-stop-rgb
  (foreign-lambda void "cairo_pattern_add_color_stop_rgb"
                       cairo_pattern_t double double double double))

(define cairo-pattern-add-color-stop-rgba
  (foreign-lambda void "cairo_pattern_add_color_stop_rgba"
                       cairo_pattern_t double double double double double))

(define cairo-pattern-set-matrix
  (foreign-lambda void "cairo_pattern_set_matrix" cairo_pattern_t cairo_matrix_t))

(define cairo-pattern-get-matrix
  (foreign-lambda void "cairo_pattern_get_matrix" cairo_pattern_t cairo_matrix_t))

(define-cairo-enum cairo_extend_t
    CAIRO_EXTEND_NONE
    CAIRO_EXTEND_REPEAT
    CAIRO_EXTEND_REFLECT
    CAIRO_EXTEND_PAD
)

(define cairo-pattern-set-extend
  (foreign-lambda void "cairo_pattern_set_extend" cairo_pattern_t cairo_extend_t))

(define cairo-pattern-get-extend
  (foreign-lambda cairo_extend_t "cairo_pattern_get_extend" cairo_pattern_t))

(define-cairo-enum cairo_filter_t
    CAIRO_FILTER_FAST
    CAIRO_FILTER_GOOD
    CAIRO_FILTER_BEST
    CAIRO_FILTER_NEAREST
    CAIRO_FILTER_BILINEAR
    CAIRO_FILTER_GAUSSIAN
)

(define cairo-pattern-set-filter
  (foreign-lambda void "cairo_pattern_set_filter" cairo_pattern_t cairo_filter_t))

(define cairo-pattern-get-filter
  (foreign-lambda cairo_filter_t "cairo_pattern_get_filter" cairo_pattern_t))

; Pattern getters return #f if the pattern is of the wrong type.

(define cairo-pattern-get-rgba*
  (foreign-lambda cairo_status_t "cairo_pattern_get_rgba" cairo_pattern_t (c-pointer double) (c-pointer double) (c-pointer double) (c-pointer double)))

(define (cairo-pattern-get-rgba cp)
  (let-location ([red double] [green double] [blue double] [alpha double])
    (let ([status (cairo-pattern-get-rgba* cp
                                           (location red)
                                           (location green)
                                           (location blue)
                                           (location alpha))])
      (if (eq? status CAIRO_STATUS_SUCCESS)
          (list red green blue alpha)
          #f))))

(define cairo-pattern-get-surface*
  (foreign-lambda cairo_status_t "cairo_pattern_get_surface" cairo_pattern_t (c-pointer cairo_surface_t)))

(define (cairo-pattern-get-surface cp)
  (let-location ([cs cairo_surface_t])
    (let ([status (cairo-pattern-get-surface* cp (location cs))])
      (if (eq? status CAIRO_STATUS_SUCCESS)
          cs
          #f))))

(define cairo-pattern-get-color-stop-rgba*
  (foreign-lambda cairo_status_t
                  "cairo_pattern_get_color_stop_rgba"
                  cairo_pattern_t
                  int
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)))

(define (cairo-pattern-get-color-stop-rgba cp index)
  (let-location ([offset double] [red double] [green double] [blue double] [alpha double])
    (let ([status (cairo-pattern-get-color-stop-rgba* cp
                                                      index
                                                      (location offset)
                                                      (location red)
                                                      (location green)
                                                      (location blue)
                                                      (location alpha))])
      (if (eq? status CAIRO_STATUS_SUCCESS)
          (list offset red green blue alpha)
          #f))))

(define cairo-pattern-get-color-stop-count*
  (foreign-lambda cairo_status_t "cairo_pattern_get_color_stop_count" cairo_pattern_t (c-pointer int)))

(define (cairo-pattern-get-color-stop-count cp)
  (let-location ([count int])
    (let ([status (cairo-pattern-get-color-stop-count* cp (location count))])
      (if (eq? status CAIRO_STATUS_SUCCESS)
          count
          #f))))

(define cairo-pattern-get-linear-points*
  (foreign-lambda cairo_status_t
                  "cairo_pattern_get_linear_points"
                  cairo_pattern_t
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)))

(define (cairo-pattern-get-linear-points cp)
  (let-location ([x0 double] [y0 double] [x1 double] [y1 double])
    (let ([status (cairo-pattern-get-linear-points* cp
                                                    (location x0)
                                                    (location y0)
                                                    (location x1)
                                                    (location y1))])
      (if (eq? status CAIRO_STATUS_SUCCESS)
          (list x0 y0 x1 y1)
          #f))))

(define cairo-pattern-get-radial-circles*
  (foreign-lambda cairo_status_t
                  "cairo_pattern_get_radial_circles"
                  cairo_pattern_t
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)
                  (c-pointer double)))

(define (cairo-pattern-get-radial-circles cp)
  (let-location ([x0 double] [y0 double] [r0 double] [x1 double] [y1 double] [r1 double])
    (let ([status (cairo-pattern-get-radial-circles* cp
                                                     (location x0)
                                                     (location y0)
                                                     (location r0)
                                                     (location x1)
                                                     (location y1)
                                                     (location r1))])
      (if (eq? status CAIRO_STATUS_SUCCESS)
          (list x0 y0 r0 x1 y1 r1)
          #f))))

; ------------------------------------------------

; Matrix operations
; ------------------------------------------------

; (cairo_matrix_t defined earlier)

; NB: These may be renamed to cairo_transform_* in future
; versions of Cairo.

(define cairo-matrix-init-identity
  (foreign-lambda void
                  "cairo_matrix_init_identity"
                  cairo_matrix_t))

(define cairo-matrix-init
  (foreign-lambda void
                  "cairo_matrix_init"
                  cairo_matrix_t
                  double double ;; a, b
                  double double ;; c, d
                  double double ;; tx, ty
                  ))

(define cairo-matrix-translate
  (foreign-lambda void
                  "cairo_matrix_translate"
                  cairo_matrix_t
                  double double ;; x, y
                  ))

(define cairo-matrix-scale
  (foreign-lambda void
                  "cairo_matrix_scale"
                  cairo_matrix_t
                  double double ;; x, y
                  ))

(define cairo-matrix-rotate
  (foreign-lambda void
                  "cairo_matrix_rotate"
                  cairo_matrix_t
                  double ;; radians
                  ))

(define cairo-matrix-invert
  (foreign-lambda cairo_status_t
                  "cairo_matrix_invert"
                  cairo_matrix_t))

(define cairo-matrix-multiply
  (foreign-lambda void
                  "cairo_matrix_multiply"
                  cairo_matrix_t ;; dest
                  cairo_matrix_t
                  cairo_matrix_t))

(define cairo-matrix-transform-distance*
  (foreign-lambda void "cairo_matrix_transform_distance"
                  cairo_matrix_t (c-pointer double) (c-pointer double)))

(define (cairo-matrix-transform-distance matrix dx dy)
  (let-location ([dx double dx] [dy double dy])
    (cairo-matrix-transform-distance* matrix (location dx) (location dy))
    (values dx dy)))

(define cairo-matrix-transform-point*
  (foreign-lambda void "cairo_matrix_transform_point"
                  cairo_matrix_t (c-pointer double) (c-pointer double)))

(define (cairo-matrix-transform-point matrix x y)
  (let-location ([x double x] [y double y])
    (cairo-matrix-transform-point* matrix (location x) (location y))
    (values x y)))
